#include "stdafx.h"
#include "string.h"
#include "ctype.h"
#include "stdio.h"
#include "stdlib.h"
#include "libindex.h"


char num2letter(float znamka) // peveden seln hodnoty na psmenn vyjden znmky
{
	if (znamka == 1) 
		return 'A';
	else if (znamka == 1.5) 
		return 'B';
	else if (znamka == 2) 
		return 'C';
	else if (znamka == 2.5) 
		return 'D';
	else if (znamka == 3) 
		return 'E';
	else if (znamka == 4)
		return 'F';
	else return '0';
}

float letter2num(char pismeno) // peveden psmennho vyjden znmky na selnou hodnotu
{
	if (pismeno == 'A') 
		return 1;
	else if (pismeno == 'B') 
		return 1.5;
	else if (pismeno == 'C') 
		return 2;
	else if (pismeno == 'D') 
		return 2.5;
	else if (pismeno == 'E') 
		return 3;
	else if (pismeno == 'F')
		return 4;
}

float avg_year(student *studenti, int student, int semestr) // ven prmr znmek studenta za dan rok (ve kterm se nachz pslun semestr)
{
	// vpoet venho prmru: (znmka1*poet_kredit1 + znmka2*poet_kredit2 + ...)/(poet_kredit1 + poet_kredit2 + ...)
	int i, j;
	float znamka, kredity; // doasn hodnoty znmky a kredit v cyklu
	float soucet_vah, soucet_kreditu; // souet kredit*hodnoty znmky, souet kredit (z tchto hodnot se vypote ven prmr)
		if (semestr % 2 == 1) semestr--; // nastaven na prvn semestr v danm roce (pokud je zbytek po dlen 2, pak se jedn o sud semestr - slovno od 0)
		for (i=0; i<2; i++)
		for (j=0; j<5; j++)
		{
			// oeten, aby se nezadan znmky nebo kredity (=0) nezapotvaly do prmru - pokud plat podmnka, je zbytek cyklu peskoen
			if (studenti[student].predmety[semestr+i][j].znamka == 0 || studenti[student].predmety[semestr+i][j].kredity == 0)
				continue;
			
			// souet vah znmek (poet_kredit * znmka)
			soucet_vah += studenti[student].predmety[semestr+i][j].znamka * studenti[student].predmety[semestr+i][j].kredity;
			soucet_kreditu+= studenti[student].predmety[semestr+i][j].kredity;
		}

	return soucet_vah/soucet_kreditu;	// navrcen vsledn hodnoty venho prmru
}

float avg_total(student *studenti, int student)	// vpoet venho prmru za celou dobu studia
{
	int i, j;
	float znamka, kredity; // doasn hodnoty znmky a kredit v cyklu
	float soucet_vah, soucet_kreditu; // souet kredit*hodnoty znmky, souet kredit (z tchto hodnot se vypote ven prmr)

	for (i=0; i<10; i++)
		for (j=0; j<5; j++)
		{
			// oeten, aby se nezadan znmky nebo kredity (=0) nezapotvaly do prmru
			if (studenti[student].predmety[i][j].znamka == 0 || studenti[student].predmety[i][j].kredity == 0)
				continue;

			soucet_vah += studenti[student].predmety[i][j].znamka * studenti[student].predmety[i][j].kredity;
			soucet_kreditu+= studenti[student].predmety[i][j].kredity;
		}

	return soucet_vah/soucet_kreditu;
}

void saveToFile(char *filename, student *studenti, int pocet_stud)	// uloen hodnot pole student do souboru
{
	// funkce na zpis zznam do souboru ve formtu poad_studenta;jmno;semestr;slo_pedm;kd_pedm;nzev_pedm;kredity;znmka\n
	FILE *pfile = NULL;
	char tmp[20];	// buffer pro konverzi mezi datovmi typy (int->string, float->string)
	int i, j, k = 0;

	pfile = fopen(filename, "wt");	// oteven textovho souboru pro zpis

	if (pfile != NULL)	// pokraujeme pouze pokud se zdailo oteven souboru
	{
		for (i=0; i<pocet_stud; i++)
			for (j=0; j<10; j++)
			{
				for (k=0; k<5; k++)
				{
					itoa(i, tmp, 10); // peveden sla i z int na string a uloen do doasn promnn tmp
					fputs(tmp, pfile);	// zpis obsahu promnn tmp (poadovho sla studenta) do souboru
					fputc(';', pfile);	// zpis oddlovae (stednku) do souboru
					fputs(studenti[i].jmeno, pfile);	// zpis jmna studenta do souboru
					fputc(';', pfile);
					itoa(j, tmp, 10);
					fputs(tmp, pfile);	// zpis sla semestru do souboru
					fputc(';', pfile);
					itoa(k, tmp, 10);
					fputs(tmp, pfile);	// zpis sla pedmtu do souboru
					fputc(';', pfile);
					fputs(studenti[i].predmety[j][k].kod, pfile);	// zpis kdu pedmtu do souboru
					fputc(';', pfile);
					fputs(studenti[i].predmety[j][k].nazev, pfile);	// zpis nzvu pedmtu do souboru
					fputc(';', pfile);
					itoa(studenti[i].predmety[j][k].kredity, tmp, 10);
					fputs(tmp, pfile);	// zpis potu kredit za pedmt do souboru
					fputc(';', pfile);
					sprintf(tmp, "%2.1f", studenti[i].predmety[j][k].znamka); // pevod hodnoty znmky z typu float na string (char *)
					fputs(tmp, pfile); // zpis znmky z pedmtu do souboru
						if (i < pocet_stud - 1 || j < 9 || k < 4) fputc('\n', pfile); // nov dek (\n) za kadm zznamem s vjimkou poslednho, tzn. pokud i, j, k nejsou na svch maximlnch hodnotch
				}
			}
		}

		fclose(pfile);	// uzaven souboru po dokonen zpisu
}

void loadFromFile(char *filename, student *studenti, int *pocet_stud)
{
	// funkce na naten zznam ze souboru ve formtu poad_studenta;jmno;semestr;slo_pedm;kd_pedm;nzev_pedm;kredity;znmka\n
	FILE *pfile = NULL;
	char tmp[100];	// buffer pro natn poloek (oddlench stednkem) ze souboru
	int i, j, k, p = 0;

	pfile = fopen(filename, "rt");	// oteven textovho souboru pro ten

	p = loadPart(pfile, tmp);	// naten prvn poloky zznamu ze souboru
	while (p != 0) // natn dat, dokud se nenaraz na konec souboru
	{
		i = atoi(tmp);
		loadPart(pfile, tmp); // jmno studenta
		strcpy(studenti[i].jmeno, tmp);
		loadPart(pfile, tmp); // semestr
		j = atoi(tmp);
		loadPart(pfile, tmp); // slo pedmtu
		k = atoi(tmp);
		loadPart(pfile, tmp); // kd pedmtu
		strcpy(studenti[i].predmety[j][k].kod, tmp);
		loadPart(pfile, tmp); // nzev pedmtu
		strcpy(studenti[i].predmety[j][k].nazev, tmp);
		loadPart(pfile, tmp); // kredity
		studenti[i].predmety[j][k].kredity = atoi(tmp);
		loadPart(pfile, tmp); // znmka
		studenti[i].predmety[j][k].znamka = atof(tmp);
		p = loadPart(pfile, tmp);
	}

	*pocet_stud = i+1;	// nastaven potu student v poli
	fclose(pfile);	// uzaven souboru po ukonen ten

}

int loadPart(FILE *pfile, char *buffer) // naten sti souboru do dalho stednku nebo konce souboru
{
	int i = 0;
	char tmp;

	// natn znak ze soubor, dokud se nenaraz na konec souboru (EOF) nebo oddlova poloek (stednk, resp. konec dku \n)
	while ((tmp = fgetc(pfile)) != EOF && tmp != ';' && tmp != '\n')
		buffer[i++] = tmp;

	buffer[i] = '\0';	// ukonen etzce v promnn tmp znakem \0

	if (tmp == EOF) return 0;	// nvratov hodnota fce loadPart bude 0, pokud se naraz na konec souboru, jinak bude 1
	else return 1;
}
