#include "stdafx.h"
#include "string.h"
#include "ctype.h"
#include "stdio.h"
#include "stdlib.h"

typedef struct zaznam	// struktura popisujc 1 zznam studenta v seznamu
{
	char kod[5];	// kd pedmtu
	char nazev[50];	// nzev pedmtu
	int kredity;	// poet kredit za absolvovn pedmtu
	float znamka;	// udlen znmka
} z;

typedef struct student	// struktura popisujc jednoho studenta
{
	char jmeno[30];			// jmno studenta
	zaznam predmety[10][5]; // 10 semestr, v kadm 5 pedmt
} s;

char num2letter(float znamka); // peveden seln hodnoty na psmenn vyjden znmky
float letter2num(char pismeno); // peveden psmennho vyjden znmky na selnou hodnotu
float avg_year(student *studenti, int student, int semestr); // ven prmr znmek studenta za dan rok (ve kterm se nachz pslun semestr)
float avg_total(student *studenti, int student);	// vpoet venho prmru za celou dobu studia
void saveToFile(char *filename, student *studenti, int pocet_stud);	// uloen hodnot pole student do souboru
void loadFromFile(char *filename, student *studenti, int *pocet_stud);
int loadPart(FILE *pfile, char *buffer); // naten sti souboru do dalho stednku nebo konce souboru